import pygame
import sys
import random
import time
from copy import deepcopy

pygame.init()

size = width, height = 400,500
black = 0,0,0

screen = pygame.display.set_mode(size)



#    0        x
#
#
#
#    y

def sled(pole):
	polesledu = [[],[],[],[],[],[],[],[]]
	x = 0
	y = 0
	jesled = False
	for radek in pole:
		for col in radek:
			pocetsledu = 0    #Pocet sledu, ve kterych je dany bod
			try:
				if pole[y][x-2] == pole[y][x-1] == pole[y][x] and pole[y][x] != 0:
					pocetsledu += 1
					jesled = True
			except IndexError:
				pass
			try:
				if pole[y][x-1] == pole[y][x+1] == pole[y][x] and pole[y][x] != 0:
					pocetsledu += 1
					jesled = True
			except IndexError:
				pass

			try:
				if pole[y][x] == pole[y][x+1] == pole[y][x+2] and pole[y][x] != 0:
					pocetsledu += 1
					jesled = True
			except IndexError:
				pass
			try:
				if pole[y-2][x] == pole[y-1][x] == pole[y][x] and pole[y][x] != 0:
					pocetsledu += 1
					jesled = True
			except IndexError:
				pass
			try:
				if pole[y-1][x] == pole[y][x] == pole[y+1][x] and pole[y][x] != 0:
					pocetsledu += 1
					jesled = True
			except IndexError:
				pass
			try:
				if pole[y][x] == pole[y+1][x] == pole[y+2][x] and pole[y][x] != 0:
					pocetsledu += 1
					jesled = True
			except IndexError:
				pass

			polesledu[y].append(pocetsledu)
			x += 1
		x = 0 
		y += 1
	if not jesled:
		return False
	return polesledu


def background():
	screen.fill(black)

	text = font.render(str(body), True, (255,255,255))
	screen.blit(text, (350,0))

	if limit != -1:
		text = font.render(str(limit/60)+":"+str(limit%60), True, (255,255,255))
		screen.blit(text, (50,0))

	pygame.draw.rect(screen, (255,255,255), (0, 40, 400, 5))
	rc = 0  #radkove cislo (kolikaty je to radek)
	for piec in npole:
		if len(piec) == 0:
			rc += 1
			continue
		if piec[0] == 1: ##RED
			pygame.draw.circle(screen, (255,0,0), (rc*50+25, 70), 25)
		elif piec[0] == 2: ##GREEN
			pygame.draw.circle(screen, (0,255,0), (rc*50+25,70), 25)
		elif piec[0] == 3: ##BLUE
			pygame.draw.circle(screen, (0,0,255), (rc*50+25,70), 25)
		elif piec[0] == 4: ##white
			pygame.draw.circle(screen, (255,255,255), (rc*50+25,70), 25)
		elif piec[0] == 5: ##yellow
			pygame.draw.circle(screen, (255,255,0), (rc*50+25,70), 25)
		elif piec[0] == 6: ##purple
			pygame.draw.circle(screen, (255,0,255), (rc*50+25,70), 25)
		rc += 1
	pygame.draw.rect(screen, (255,255,255), (0, 95, 400, 5))
	if oznacen:
		pygame.draw.rect(screen, (200,200,200), (oznacen[1]*50, oznacen[0]*50, 50, 50))



def konechry(xpole):
	konec = True
	for x in xrange(8):
		for y in xrange(8):
			try:
				a = xpole[x-2][y]
				xpole[x-2][y] = xpole[x-2][y-1]
				xpole[x-2][y-1] = a
				if not sled(xpole):
					a = xpole[x-2][y]
					xpole[x-2][y] = xpole[x-2][y-1]
					xpole[x-2][y-1] = a
				else:
					konec = False
					break
			except IndexError:
				pass

			try:
				a = xpole[x-2][y]
				xpole[x-2][y] = xpole[x-2-1][y]
				xpole[x-2-1][y] = a
				if not sled(xpole):
					a = xpole[x-2][y]
					xpole[x-2][y] = xpole[x-2-1][y]
					xpole[x-2-1][y] = a
				else:
					konec = False
					break
			except IndexError:
				pass

			try:
				a = xpole[x-2][y]
				xpole[x-2][y] = xpole[x-2+1][y]
				xpole[x-2+1][y] = a
				if not sled(xpole):
					a = xpole[x-2][y]
					xpole[x-2][y] = xpole[x-2+1][y]
					xpole[x-2+1][y] = a
				else:
					konec = False
					break
			except IndexError:
				pass

			try:
				a = xpole[x-2][y]
				xpole[x-2][y] = xpole[x-2][y+1]
				xpole[x-2][y+1] = a
				if not sled(xpole):
					a = xpole[x-2][y]
					xpole[x-2][y] = xpole[x-2][y+1]
					xpole[x-2][y+1] = a
				else:
					konec = False
					break
			except IndexError:
				pass
		if konec:
			break
	return konec


def pocitac():
	fp = open("vstup.txt", "r")
	data = fp.readlines()
	fp.close()
	xpole = []
	pocettahu = data[0]
	for radek in data[1:]:
		pole.append([])
		for piece in radek:
			pole[i].append(int(piece))    ### bacha
		i += 1
	
	i = 0

	for x in xrange(8):
		for y in xrange(8):
			try:
				a = xpole[x-2][y]
				xpole[x-2][y] = xpole[x-2][y-1]
				xpole[x-2][y-1] = a
				if not sled(xpole):
					a = xpole[x-2][y]
					xpole[x-2][y] = xpole[x-2][y-1]
					xpole[x-2][y-1] = a
				else:
					konec = False
					break
			except IndexError:
				pass

			try:
				a = xpole[x-2][y]
				xpole[x-2][y] = xpole[x-2-1][y]
				xpole[x-2-1][y] = a
				if not sled(xpole):
					a = xpole[x-2][y]
					xpole[x-2][y] = xpole[x-2-1][y]
					xpole[x-2-1][y] = a
				else:
					konec = False
					break
			except IndexError:
				pass

			try:
				a = xpole[x-2][y]
				xpole[x-2][y] = xpole[x-2+1][y]
				xpole[x-2+1][y] = a
				if not sled(xpole):
					a = xpole[x-2][y]
					xpole[x-2][y] = xpole[x-2+1][y]
					xpole[x-2+1][y] = a
				else:
					konec = False
					break
			except IndexError:
				pass

			try:
				a = xpole[x-2][y]
				xpole[x-2][y] = xpole[x-2][y+1]
				xpole[x-2][y+1] = a
				if not sled(xpole):
					a = xpole[x-2][y]
					xpole[x-2][y] = xpole[x-2][y+1]
					xpole[x-2][y+1] = a
				else:
					konec = False
					break
			except IndexError:
				pass

npole = []
pole = []

done = False
while not done:
	soubor = raw_input("Zapiste nazev souboru: ")
	try:
		fp = open(soubor, "r")
		done = True
	except:
		print "Neplatny nazev souboru"

done = False
while not done:
	try:
		cas = raw_input("Zadejte casovy limit (pro hru bez limitu zadejte -1): ")
		if cas == -1:
			limit = -1
		else:
			d = cas.split(":")
			limit = int(d[0])*60+int(d[1])
			done = True
	except:
		print "Neplatne zadano."

done = False
while not done:
 	try:
 		a = raw_input("Zadejte rychlost padu kulicek (1 az 50): ")
 		rychlostpadu = int(a)
 		done = True
 	except:
 		print "Neplatne zadano."

if limit > 0:
	start = time.time()
	endtime = start + limit
fp = open("vstup.txt", "r")
data = fp.read()
i = 0
pol = data.split()
for radek in pol[:8]:
	pole.append([])
	for piece in radek:
		pole[i].append(int(piece))    ### bacha
	i += 1
i = 0
for radek in pol[8:]:
	npole.append([])
	for pismeno in radek:
		npole[i].append(int(pismeno))
	i += 1

pygame.font.init()
jedeme = False
body = 0
oznacen = []
mousepressed = False
font = pygame.font.SysFont("", 50)

while 1:
	for event in pygame.event.get():
		if event.type == pygame.QUIT:
			sys.exit()


	background()


	x = 0
	y = 0
	for r in pole:
		for c in r:
			if c == 1: ##RED
				pygame.draw.circle(screen, (255,0,0), (x*50+25, y*50+25+100), 25)
			elif c == 2: ##GREEN
				pygame.draw.circle(screen, (0,255,0), (x*50+25, y*50+25+100), 25)
			elif c == 3: ##BLUE
				pygame.draw.circle(screen, (0,0,255), (x*50+25, y*50+25+100), 25)
			elif c == 4: ##white
				pygame.draw.circle(screen, (255,255,255), (x*50+25, y*50+25+100), 25)
			elif c == 5: ##yellow
				pygame.draw.circle(screen, (255,255,0), (x*50+25, y*50+25+100), 25)
			elif c == 6: ##purple
				pygame.draw.circle(screen, (255,0,255), (x*50+25, y*50+25+100), 25)
			x += 1
		y += 1
		x = 0


	## MOUSE CLICK
	if pygame.mouse.get_pressed()[0] and not mousepressed:
		pos = pygame.mouse.get_pos()
		x = pos[1]/50
		y = pos[0]/50
		if not oznacen:
			#print "oznacuji"
			oznacen = [x, y]
		#elif oznacen == [x, y]:
		#	oznacen = []
		elif oznacen == [x,y]:
			oznacen = []
		elif oznacen == [x,y-1]:
			##print "prohazuji", [x,y], "za", [x, y-1]

			a = pole[x-2][y]
			pole[x-2][y] = pole[x-2][y-1]
			pole[x-2][y-1] = a
			if not sled(pole):
				a = pole[x-2][y]
				pole[x-2][y] = pole[x-2][y-1]
				pole[x-2][y-1] = a

			oznacen = []
		elif oznacen == [x-1,y]:
			#print "prohazuji", [x,y], "za", [x-1, y]
			a = pole[x-2][y]
			pole[x-2][y] = pole[x-2-1][y]
			pole[x-2-1][y] = a
			if not sled(pole):
				a = pole[x-2][y]
				pole[x-2][y] = pole[x-2-1][y]
				pole[x-2-1][y] = a
			oznacen = []
		elif oznacen == [x+1,y]:
			#print "prohazuji", [x,y], "za", [x+1, y]
			a = pole[x-2][y]
			pole[x-2][y] = pole[x-2+1][y]
			pole[x-2+1][y] = a
			if not sled(pole):
				a = pole[x-2][y]
				pole[x-2][y] = pole[x-2+1][y]
				pole[x-2+1][y] = a
			oznacen = []
		elif oznacen == [x,y+1]:
			#print "prohazuji", [x,y], "za", [x, y+1]
			a = pole[x-2][y]
			pole[x-2][y] = pole[x-2][y+1]
			pole[x-2][y+1] = a
			if not sled(pole):
				a = pole[x-2][y]
				pole[x-2][y] = pole[x-2][y+1]
				pole[x-2][y+1] = a
			oznacen = []
		mousepressed = True
	if not pygame.mouse.get_pressed()[0]:
		mousepressed = False
	###MOUSECLICK



	#posun kulicek
	if jedeme:
		newpole = deepcopy(pole)
		for pocetposunu in xrange(8):
			nekdojede = False
			for posun in xrange(0, 50, rychlostpadu):
				x = 0   #sloupce
				y = 0   #radky
				background()

				for r in pole:
					for c in r:
						muzujet = False
						for mich in xrange(y, 8):
							if pole[mich][x] == 0:
								muzujet = True
								break
						if muzujet:
							nekdojede = True
							if y == 0:
								#print "Jsem nahore a nevim co mam delat"
								if posun == 0:
									#print "posun je nula tak to nahradim z npole"
									if len(npole[x]) == 0:
										newpole[y][x] = 0
									else:	
										newpole[y][x] = npole[x][0]
										npole[x].pop(0)
							else:
								newpole[y][x] = pole[y-1][x]
							if c == 1: ##RED
								pygame.draw.circle(screen, (255,0,0), (x*50+25, y*50+25+100+posun), 25)
							elif c == 2: ##GREEN
								pygame.draw.circle(screen, (0,255,0), (x*50+25, y*50+25+100+posun), 25)
							elif c == 3: ##BLUE
								pygame.draw.circle(screen, (0,0,255), (x*50+25, y*50+25+100+posun), 25)
							elif c == 4: ##white
								pygame.draw.circle(screen, (255,255,255), (x*50+25, y*50+25+100+posun), 25)
							elif c == 5: ##yellow
								pygame.draw.circle(screen, (255,255,0), (x*50+25, y*50+25+100+posun), 25)
							elif c == 6: ##purple
								pygame.draw.circle(screen, (255,0,255), (x*50+25, y*50+25+100+posun), 25)
						else:
							if c == 1: ##RED
								pygame.draw.circle(screen, (255,0,0), (x*50+25, y*50+25+100), 25)
							elif c == 2: ##GREEN
								pygame.draw.circle(screen, (0,255,0), (x*50+25, y*50+25+100), 25)
							elif c == 3: ##BLUE
								pygame.draw.circle(screen, (0,0,255), (x*50+25, y*50+25+100), 25)
							elif c == 4: ##white
								pygame.draw.circle(screen, (255,255,255), (x*50+25, y*50+25+100), 25)
							elif c == 5: ##yellow
								pygame.draw.circle(screen, (255,255,0), (x*50+25, y*50+25+100), 25)
							elif c == 6: ##purple
								pygame.draw.circle(screen, (255,0,255), (x*50+25, y*50+25+100), 25)
						x += 1

					y += 1
					x = 0
				pygame.display.flip()
				pygame.event.pump()
			jedeme = False
			pole = deepcopy(newpole)
			if not nekdojede:
				break

	####  JE SLED
	if not jedeme:
		sl = sled(pole)
		if sl:
			r = 0
			c = 0
			for row in sl:
				for cl in row:
					body += cl
					if cl:
						pole[r][c] = 0
					c += 1
				r += 1
				c = 0
			jedeme = True

	## KONEC HRY?
	xpole = deepcopy(pole)
	if konechry(xpole):
		break
	if limit != -1:
		limit = int(endtime-time.time())
	if limit == 0:
		break
	#time.time()
	pygame.display.flip()
	pygame.event.pump()
screen.fill(black)
text = font.render(str("KONEC HRY"), True, (255,255,255))
screen.blit(text, (100,100))
text = font.render(str("Pocet bodu: %s" %str(body)), True, (255,255,255))
screen.blit(text, (100,300))
pygame.display.flip()
pygame.event.pump()
raw_input()
